package jdk.internal.org.objectweb.asm.commons;

import jdk.internal.org.objectweb.asm.AnnotationVisitor;

public class RemappingAnnotationAdapter extends AnnotationVisitor
{
    protected final Remapper remapper;
    
    public RemappingAnnotationAdapter(AnnotationVisitor annotationVisitor, Remapper remapper) {
        this(327680, annotationVisitor, remapper);
    }
    
    protected RemappingAnnotationAdapter(int api, AnnotationVisitor annotationVisitor, Remapper remapper) {
        super(api, annotationVisitor);
        this.remapper = remapper;
    }
    
    @Override
    public void visit(String name, Object o) {
        this.av.visit(name, this.remapper.mapValue(o));
    }
    
    @Override
    public void visitEnum(String name, String s, String value) {
        this.av.visitEnum(name, this.remapper.mapDesc(s), value);
    }
    
    @Override
    public AnnotationVisitor visitAnnotation(String name, String s) {
        AnnotationVisitor visitAnnotation = this.av.visitAnnotation(name, this.remapper.mapDesc(s));
        return (visitAnnotation == null) ? null : ((visitAnnotation == this.av) ? this : new RemappingAnnotationAdapter(visitAnnotation, this.remapper));
    }
    
    @Override
    public AnnotationVisitor visitArray(String name) {
        AnnotationVisitor visitArray = this.av.visitArray(name);
        return (visitArray == null) ? null : ((visitArray == this.av) ? this : new RemappingAnnotationAdapter(visitArray, this.remapper));
    }
}
